<?php

function action_incarner_dist() {

	$securiser_action = charger_fonction('securiser_action', 'inc');
	$arg = $securiser_action();

	$arg = explode(':', $arg, 2);
	$action = array_shift($arg);

	include_spip('inc/headers');
	include_spip('incarner_fonctions');
	include_spip('incarner_pipelines');
	include_spip('inc/auth');

	switch ($action) {
		// verifier qu'on a envoye un login licite
		case 'login':
			if ($login = array_shift($arg)){
				// que l'on sait identifier via auth/incarner
				if ($auteur = auth_identifier_login($login, '')
					and is_array($auteur)){
					if (autoriser('incarner', 'auteur', $auteur['id_auteur'] ?? 0)){

						auth_loger($auteur);

						/* Si on vient de se loger dans l'espace privé avec un login qui n'y est
						 * pas autorisé, on redirige vers la page d'accueil, pour éviter un
						 * message d'erreur inutile. */
						if (test_espace_prive() and (!autoriser('ecrire'))){
							redirige_par_entete(url_de_base());
						}

						return;
					}

				}
			}
			break;
		case 'rollback':
			if ($id_auteur = incarner_racine_incarnation()) {

				include_spip('base/abstract_sql');
				$login = sql_getfetsel('login','spip_auteurs','id_auteur=' . intval($id_auteur));
				if ($auteur = auth_identifier_login($login, '')
					and is_array($auteur)){
					auth_loger($auteur);
					incarner_invalider_cle();

					return;
				}
			}
			break;
		case 'logout':
			if ($id_auteur = incarner_racine_incarnation()){
				incarner_invalider_cle();
				redirige_par_entete(
					html_entity_decode(
						generer_url_action('logout', 'logout=public', false, true)
					)
				);
				return;
			}
			break;
	}

	http_status(403);
	incarner_invalider_cle();
	include_spip('inc/minipres');
	echo minipres();
	exit();
}
